/////////////////////////////////////////////////////////////////////////////////
//
// B2APIEx.h
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: B2APIEx.h,v $
 */


#pragma once


/////////////////////////////////////////////////////////////////////////////////
//
#include <string>
#include <map>
#include "B2API.h"
#include "CriticalSection.h"
#include "Config.h"


#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4786)


/////////////////////////////////////////////////////////////////////////////////
//
using namespace std;


typedef map<DWORD, DWORD> MessageMap;


#define B2APIEX_GETSOURCE               1
#define B2APIEX_GETTEXT                 2
#define B2APIEX_GETHEADER               3
#define B2APIEX_COMPGETSOURCE           4
#define B2APIEX_COMPGETTEXT             5
#define B2APIEX_COMPGETHEADER           6
#define B2APIEX_SETSOURCE               7
#define B2APIEX_SETTEXT                 8
#define B2APIEX_COMPSETSOURCE           9
#define B2APIEX_COMPSETTEXT             10
#define B2APIEX_GETSPECIFIEDHEADER      11
#define B2APIEX_SETSPECIFIEDHEADER      12
#define B2APIEX_COMPGETSPECIFIEDHEADER  13
#define B2APIEX_COMPSETSPECIFIEDHEADER  14
#define B2APIEX_GETCONFIG               15
#define B2APIEX_SETCONFIG               16


/////////////////////////////////////////////////////////////////////////////////
//
class B2APIEx
{
public:
    ~B2APIEx();
    static B2API* Instance();
    static B2APIEx* InstanceEx(ConfigMgr* initConfigMgr);
    static B2APIEx* InstanceEx();

    string GetSource(LPCSTR lpMailID);
    string GetText(LPSTR lpszMimeType, int nBuf);
    string GetHeader(LPCSTR lpMailID);
    string CompGetSource(HWND hWnd);
    string CompGetText(HWND hWnd, LPSTR lpszMimeType, int nBuf);
    string CompGetHeader(HWND hWnd);

    void SetSource(LPCSTR lpMailID, LPCSTR lpSource);
    void SetText(int nMode, LPCSTR lpText);
    void CompSetSource(HWND hWnd, LPCSTR lpSource);
    void CompSetText(HWND hWnd, int nMode, LPCSTR lpText);

    void GetSpecifiedHeader(LPCSTR lpHeader, LPSTR lpszData, int nBuf);
    void SetSpecifiedHeader(LPCSTR lpHeader, LPCSTR lpszData);
    void CompGetSpecifiedHeader(HWND hWnd, LPCSTR lpHeader, LPSTR lpszData, int nBuf);
    void CompSetSpecifiedHeader(HWND hWnd, LPCSTR lpHeader, LPCSTR lpszData);

    Config GetConfig();
    void SetConfig(const Config& config);

    HWND GetMainWindowHandle();
    HWND GetTreeWindowHandle();
    HWND GetListWindowHandle();
    HWND GetViewWindowHandle();

protected:
    B2APIEx(ConfigMgr* initConfigMgr);
    bool init();

private:
    bool equalThread(HWND hWnd);

    static void WINAPI CmdProcGetSource(HWND hWnd, LPARAM lParam);
    static void WINAPI CmdProcGetText(HWND hWnd, LPARAM lParam);
    static void WINAPI CmdProcGetHeader(HWND hWnd, LPARAM lParam);
    static void WINAPI CmdProcCompGetSource(HWND hWnd, LPARAM lParam);
    static void WINAPI CmdProcCompGetText(HWND hWnd, LPARAM lParam);
    static void WINAPI CmdProcCompGetHeader(HWND hWnd, LPARAM lParam);

    static void WINAPI CmdProcSetSource(HWND hWnd, LPARAM lParam);
    static void WINAPI CmdProcSetText(HWND hWnd, LPARAM lParam);
    static void WINAPI CmdProcCompSetSource(HWND hWnd, LPARAM lParam);
    static void WINAPI CmdProcCompSetText(HWND hWnd, LPARAM lParam);

    static void WINAPI CmdProcGetSpecifiedHeader(HWND hWnd, LPARAM lParam);
    static void WINAPI CmdProcSetSpecifiedHeader(HWND hWnd, LPARAM lParam);
    static void WINAPI CmdProcCompGetSpecifiedHeader(HWND hWnd, LPARAM lParam);
    static void WINAPI CmdProcCompSetSpecifiedHeader(HWND hWnd, LPARAM lParam);

    static void WINAPI CmdProcGetConfig(HWND hWnd, LPARAM lParam);
    static void WINAPI CmdProcSetConfig(HWND hWnd, LPARAM lParam);

    static B2API* b2api;
    static B2APIEx* instance;
    static CriticalSection critsec;

    static HWND b2main;
    static HWND b2tree;
    static HWND b2list;
    static HWND b2view;
    static MessageMap message;

    static ConfigMgr* configMgr;

    static string* std_string_out;
    static LPCSTR const_string_param1;
    static LPCSTR const_string_param2;
    static LPSTR string_param1;
    static LPSTR string_param2;
    static HWND window_param1;
    static int integer_param1;
    static int integer_param2;
    static Config* config_param1;
};

#pragma warning(pop) /* restore previous warning */
