/*!
 * @file BkMail.hpp
 * @brief rfc2822`̃bZ[WIuWFNgNXȂǁB
 * @author  Copyright (C) 2000-2002 YUGA <yuga@ops.dti.ne.jp>
 * $Date: 2002/04/15 01:54:11 $
 * $Revision: 1.2 $
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 */


#pragma once
#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4786)


/////////////////////////////////////////////////////////////////////////////////
//
#include <windows.h>
#include <algorithm>
#include <functional>
#include <list>
#include <string>
#include <locale>
#include "LineReader.h"
#include "tokenizer.h"
//#define _STL_EQUAL_IOSTREAM
#ifdef _STL_EQUAL_IOSTREAM
#include "b2mailstream.h"
#endif

/////////////////////////////////////////////////////////////////////////////////
//
using namespace std;

class BkMail;
typedef list<string > StringList;
typedef list<BkMail* > BkMailList;


/////////////////////////////////////////////////////////////////////////////////
//
/// qp[g猟
#define FINDMIMEITEM_CHILD          0x00000001
/// p[g猟
#define FINDMIMEITEM_NEXT           0x00000002
/// ŏɌ郋[giqp[gEp[gj͍ŏ̃p[g
#define FINDMIMEITEM_FIRST_ONE      0x00000004
/// ԖڂɌ郋[gip[gEqp[gj͍ŏ̃p[g
#define FINDMIMEITEM_SECOND_ONE     0x00000008
/// ŏɌ郋[giqp[gEp[gj͑SẴp[g猟
#define FINDMIMEITEM_FIRST_SOME     0x00000010
/// ԖڂɌ郋[gip[gEqp[gj͑SẴp[g猟
#define FINDMIMEITEM_SECOND_SOME    0x00000020
/// ŏɎqp[g̃[g猟
#define FINDMIMEITEM_FIRST_CHILD    0x00000041
/// ŏɒp[g̃[g猟
#define FINDMIMEITEM_FIRST_NEXT     0x00000082
/// ŏɎqp[g̃[gׂĂ猟Aɒp[g̃[gׂĂ猟
#define FINDMIMEITEM_DEFAULT        FINDMIMEITEM_FIRST_CHILD | \
                                    FINDMIMEITEM_FIRST_SOME | \
                                    FINDMIMEITEM_NEXT | \
                                    FINDMIMEITEM_SECOND_SOME
/// ŏɎqp[g̃[gŏ̃p[gAɒp[g̃[gׂĂ猟
#define FINDMIMEITEM_UNDER_STAGE    FINDMIMEITEM_FIRST_CHILD   | \
                                    FINDMIMEITEM_FIRST_ONE | \
                                    FINDMIMEITEM_NEXT | \
                                    FINDMIMEITEM_SECOND_SOME

/**
 * @brief BkMailNXp̃}`p[gǗNXB
 *
 * ܂fUCǂȂłB
 * ܂ɂĎv΁ABkMultipartManagerBkMailʃNẌӖ܂B
 * ŜV蒼̂łAƂ݌vłȂłˁB
 */
class BkMultipartManager
{
public:
    // Constructer
    BkMultipartManager();
    virtual ~BkMultipartManager();

    // mime type
    virtual const string& getType() const { return type; }
    virtual const string& getSubtype() const { return subtype; }
    virtual const string& getBoundary() const { return boundary; }
    virtual void setType(const string& newType) { type = newType; }
    virtual void setSubtype(const string& newSubtype) { subtype = newSubtype; }
    virtual void setBoundary(const string& newBoundary) { boundary = newBoundary; }

    // multipart\
    BkMail* getChild() const;
    BkMail* getNext() const;
    BkMail* setChild(BkMail* newChild);
    BkMail* addChild(BkMail* newChild);
    BkMail* setNext(BkMail* newNext);

    // mime item
    virtual BkMailList::iterator find(const BkMail* item, const string& forType, const string& forSubtype, unsigned int flag);
    virtual BkMailList::iterator end() { return resultSearch.end(); }

protected:
    // Tree
    virtual void explore(const BkMail* item, const string& forType, const string& forSubtype, unsigned int flag);

private:
    string type;
    string subtype;
    string boundary;

    BkMail* child;
    BkMail* next;

    BkMailList resultSearch;
};


/////////////////////////////////////////////////////////////////////////////////
//
/**
 * @brief rfc822bZ[WNXB
 * ̃NXBecky! Internet Mail version 2擾郁[\[XƂɁA
 * mime multipart itemPʂł̃[f[^s悤ɂĂB
 * 揼CMIMEItemՂɁASTLōč\zB
 */
class BkMail
{
public:
    // constructer
    BkMail() {}
    explicit BkMail(const string& initSource) { fromString(initSource); }
    virtual ~BkMail();

    // o
    virtual void fromString(const string& newSource, const string& boundaryParent="");
    virtual void fromString(LineReader& first, LineReader& last, const string& boundaryParent= "");
    virtual string toString() const;

    // multipart
    /**
     * qp[g̎擾
     * @return }`p[g̏ꍇA擪̎qp[głBkMailCX^XB
     *         qp[gȂꍇANULLB
     */
    virtual BkMail* getChild() const { return multipart.getChild(); }

    /**
     * p[g̎擾
     * @return ep[g̎}`p[ĝЂƂłꍇA
     *         ̃p[głBkMailCX^XB
     *         ̃p[gȂꍇANULLB
     */
    virtual BkMail* getNext() const { return multipart.getNext(); }

    /**
     * qp[g̊i[
     * X̎qp[g폜āAVqp[gi[B
     * @note ŏqp[gĂȂꍇłAContent-Type̐ݒȂǂ͍sȂB
     * @param newChild [in] Vi[qp[g
     * @return ͂newChildg
     */
    virtual BkMail* setChild(BkMail* newChild) { return multipart.setChild(newChild); }

    /**
     * qp[g̒ǉi[
     * i[ς݂̎qp[ǧɒǉ`ŁAVqp[gi[B
     * @param newChild [in] Vǉi[qp[g
     * @return ͂newChildg
     */
    virtual BkMail* addChild(BkMail* newChild) { return multipart.addChild(newChild); }

    /**
     * p[g̊i[
     * X̒p[gׂ͂č폜āAVp[gi[B
     * @param newChild [in] Vi[p[g
     * @return ͂newNextg
     */
    virtual BkMail* setNext(BkMail* newNext) { return multipart.setNext(newNext); }

    // Content-Type擾
    virtual const string& getType() const { return multipart.getType(); }
    virtual const string& getSubtype() const { return multipart.getSubtype(); }
    virtual const string& getBoundary() const { return multipart.getBoundary(); }
    virtual bool isMime(const string& toType, const string& toSubtype);

    // mime item
    /// ep[ǧ
    /**
     * Content-TypeTypeSubtypeL[Ɋep[gA
     * Yp[gXg`BkMailIuWFNg̂ŁA̐擪wCe^[擾B
     * ep[ǧw\B
     * @param item       [in] ΏۂBkMailCX^X
     * @param forType    [in] L[ƂȂAContent-TypeType
     * @param forSubtype [in] L[ƂȂAContent-TypeSubtype
     * @param flag       [in] w肷tO
     * @return ʁBYBkMailCX^Xi[BkMailListIuWFNg̐擪witeratorB
     */
    virtual BkMailList::iterator findMimeItem(const string& forType, const string& forSubtype, unsigned int flag)
        { return multipart.find(this, forType, forSubtype, flag); }

    /**
     * ep[ǧ
     * findMimeItem()sʁA
     * Yp[gXg`BkMailIuWFNg̂ŁȀI[wCe^[擾B
     * @note findMimeItem()ƂƂɎgp邱ƁB
     * @return ʁBYBkMailCX^Xi[BkMailListIuWFNg̏I[witeratorB
     */
    virtual BkMailList::iterator end() { return multipart.end(); }

    // headerA͋@\tistringŁj
    virtual string getHeader(const string& name);
    virtual void setHeader(const string& name, const string& data);

    // headers, body, trailistringŁj
    virtual void pushHeaderFront(const string& data);
    virtual void pushHeaderBack(const string& data);
    virtual void clearHeader();
    virtual void pushBodyFront(const string& data);
    virtual void pushBodyBack(const string& data);
    virtual void clearBody();
    virtual void pushTrailFront(const string& data);
    virtual void pushTrailBack(const string& data);
    virtual void clearTrail();

    // attached rfc822 message
    virtual BkMail* getRfc822();

protected:
    // headers, body, trailANZT
    /// headersXg擾
    virtual StringList& getHeaders() { return headers; }
    /// BodyXg擾
    virtual StringList& getBody() { return body; }
    /// TrailXg擾
    virtual StringList& getTrail() { return trail; }

    // ̓[\[X
    /**
     * VBkMailCX^X쐬
     * @note BkMailNX̔hNXꍇÃb\hI[o[Ch邱ƁB
     * @return VBkMailCX^X
     */
    virtual BkMail* createInstance() { return new BkMail(); }
    virtual void parseHeaders(LineReader& first, LineReader& last);
    virtual void parseBody(LineReader& first, LineReader& last, const string& boundary);
    virtual void connectHeaderLine(LineReader& first, LineReader& last, string& linebuf);
    virtual void parseContentType(const string& header);
    virtual bool getOption(string::iterator& begin, string::iterator& end, string& option, string& value);

private:
    StringList headers; // wb_̃Xg
    StringList body; // {̃XgiboundaryOj
    StringList trail; // {̃Xg(boundaryj

    BkMultipartManager multipart;
};


/////////////////////////////////////////////////////////////////////////////////
//
namespace std {
/**
 * functional: equal_to_break
 * @brief Content-Typewb_̃IvVC̋؂蕶p̊֐IuWFNg
 */
template<class _Ty>
  struct equal_to_break : unary_function<_Ty, bool > {
  bool operator()(const _Ty& _X) const
    {return (_X == '\t' || _X == '\x20' || _X == ';' || _X == '\r' || _X == '\n'); }
  };


/**
 * functional: not_equal_to_break
 * @brief Content-Typewb_̃IvVC̋؂蕶p̊֐IuWFNg
 */
template<class _Ty>
  struct not_equal_to_break : unary_function<_Ty, bool > {
  bool operator()(const _Ty& _X) const
    {return (_X != '\t' && _X != '\x20' && _X != ';' && _X != '\r' && _X != '\n'); }
  };


/**
 * functional: not_equal_to_lswp
 * @brief wb_̋؂蕶p
 */
template<class _Ty>
  struct not_equal_to_lswp : unary_function<_Ty, bool > {
  bool operator()(const _Ty& _X) const
    {return (_X != '\t' && _X != '\x20' && _X != '\r' && _X != '\n'); }
  };

} //namespace


#ifdef _STL_EQUAL_IOSTREAM
/////////////////////////////////////////////////////////////////////////////////
//
template<class _E, class _Tr> inline
    basic_b2mailstream<_E, _Tr>& __cdecl operator>>(
        basic_b2mailstream<_E, _Tr>& _I,
        BkMail& _M)
    {typedef basic_istream<_E, _Tr> _Myis;
    basic_string<_E, _Tr> _X;
    basic_b2mailbuf<_E, _Tr>* _B;
    ios_base::iostate _St = ios_base::goodbit;
    _X.erase();
    const _Myis::sentry _Ok(_I);
    if (_Ok)
        {_B = _I.rdbuf();
        _X = _B->str();
        _St |= ios_base::eofbit;
        _M.fromString(_X); }
    else
        {_St |= ios_base::failbit; }
    _I.setstate(_St);
    return (_I); }


template<class _E, class _Tr> inline
    basic_b2mailstream<_E, _Tr>& __cdecl operator<<(
        basic_b2mailstream<_E, _Tr>& _O,
        const BkMail& _X)
    {_O.str(_X.toString());
    return (_O); }


#ifdef _DLL
#pragma warning(disable:4231) // the extern before template is a non-standard extension

extern template class _CRTIMP
    b2mailstream& __cdecl operator>>(b2mailstream& _I, BkMail& _M, allocator<char> >&);
extern template class _CRTIMP
    b2mailstream& __cdecl operator>>(b2mailstream& _O, const BkMail& _M, allocator<char> >&);

#pragma warning(default:4231) // restore previous warning
#endif      // _DLL


#endif //_STL_EQUAL_IOSTREAM
/////////////////////////////////////////////////////////////////////////////////
//

#pragma warning(pop) /* restore previous warning */
