/**
 * @file Config.h
 * @brief IvVݒ̏NX̒`
 * @author  Copyright (C) 2002 YUGA <yuga@ops.dti.ne.jp>
 * $Date: $
 * $Revision: $
 *
 */

#pragma once
#include <windows.h>
#include <string>
#include "CriticalSection.h"


/////////////////////////////////////////////////////////////////////////////////
//
using namespace std;


/////////////////////////////////////////////////////////////////////////////////
//
class Config
{
public:
    Config();
    Config(const Config& initConfig);
    virtual ~Config();
    virtual Config& operator=(const Config& newConfig);

    virtual bool isEncryptDefaultKey() const;
    virtual void setEncryptDefaultKey(bool use);
    virtual bool isSaveDecryptPassphrase();
    virtual void setSaveDecryptPassphrase(bool save);
    virtual const SYSTEMTIME& getSaveTimeDecryptPassphrase() const;
    virtual void setSaveTimeDecryptPassphrase(const SYSTEMTIME& time);
    virtual bool isSaveSignPassphrase();
    virtual void setSaveSignPassphrase(bool save);
    virtual const SYSTEMTIME& getSaveTimeSignPassphrase() const;
    virtual void setSaveTimeSignPassphrase(const SYSTEMTIME& time);

    virtual bool isUsePGPlog();
    virtual bool isDisplayVerificationResultOnListView();
    virtual DWORD getDisplayTimeVerificationResult();
    virtual const COLORREF& getDisplayColorVerificationCorrect();
    virtual const COLORREF& getDisplayColorVerificationInCorrect();
    virtual bool isEraseBackgroundOfListView();

    virtual void setUsePGPlog(bool use);
    virtual void setDisplayVerificationResultOnListView(bool display);
    virtual void setDisplayTimeVerificationResult(DWORD time);
    virtual void setDisplayColorVerificationCorrect(const COLORREF& color);
    virtual void setDisplayColorVerificationInCorrect(const COLORREF& color);
    virtual void setEraseBackgroundOfListView(bool erase);

protected:

private:
    // Settings
    bool encryptDefaultKey;         // Default KeygĈÍ邩H
    bool saveDecryptPassphrase;     // ppXt[YLbV邩H
    SYSTEMTIME stDecrypt;           // ppXt[ỸLbV
    bool saveSignPassphrase;        // ppXt[YLbV邩H
    SYSTEMTIME stSign;              // ppXt[ỸLbV

    // ExpertSettings
    bool usePGPlog;                             // PGPloggp邩H
    bool displayVerificationResultOnListView;   // ،ʂXgr[ɕ\邩H
    DWORD dtVerificationResult;                 // ،ʂXgr[ɕ\鎞
    COLORREF dcVerificationCorrect;             // ،"Good Signature"̐F
    COLORREF dcVerificationInCorrect;           // ،"Bad Signature"̐F
    bool eraseBackgroundOfListView;             // ،ʂ\ƂXg[̔wi邩H
};


/////////////////////////////////////////////////////////////////////////////////
//
class ConfigMgr
{
public:
    ConfigMgr(const string& fullpath);
    virtual ~ConfigMgr();
    
    virtual void save();
    virtual void load();

    virtual Config get();
    virtual void set(const Config& newConfig);

protected:

private:
    Config config;
    string iniFilePath;
};


/////////////////////////////////////////////////////////////////////////////////
//
