/////////////////////////////////////////////////////////////////////////////////
//
// LineReader.h
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: LineReader.h,v $
 * Revision 1.3  2001/01/20 07:40:15  syou
 * - Í̍ہAToACcABcc̃AhXDefault RecipientƂĈ悤ɂA
 *   ܂Cӂ̌JgĈÍł悤ɂB܂ADefault Recipient
 *   Default Private Key̒ǉ\ɂIvV݂BA
 *   ͂Ȃr(^^;
 *
 * Revision 1.2  2000/11/29 12:46:34  syou
 * - broken version line ̏CBsɂ܂Ă͖̂炩Ƀ~X
 *   łB
 *
 * Revision 1.1  2000/11/07 15:57:18  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 */


#pragma once


/////////////////////////////////////////////////////////////////////////////////
//
#include <algorithm>
#include <string>


/////////////////////////////////////////////////////////////////////////////////
//
using namespace std;


/////////////////////////////////////////////////////////////////////////////////
//
class LineReader : public iterator<input_iterator_tag, string>
{
    string src_;    // ΏۂƂȂ镶
    string tok_;    // ؂oꂽ

    string::size_type first_;
    string::size_type last_;

    bool crlf_;

    string::size_type find_first();
    void get_value();

public:
    LineReader() : first_(string::npos), last_(string::npos), crlf_(false) {  tok_.reserve(65540);    }
    LineReader(const string& src) : src_(src)
    {   last_ = 0;  tok_.reserve(65540);    get_value();    }
    LineReader(const char* src) : src_(src)
    {   last_ = 0;  tok_.reserve(65540);    get_value();    }
    LineReader(const LineReader& t)
        : src_(t.src_), tok_(t.tok_), first_(t.first_), last_(t.last_), crlf_(t.crlf_)
    {}
    virtual ~LineReader() {};

    LineReader& operator=(const LineReader& t) {
        src_ = t.src_;  tok_ = t.tok_;
        first_ = t.first_;  last_ = t.last_;    crlf_ = t.crlf_;
        return *this;
    }

    // Ώەݒ
    LineReader& operator=(const string& src)
    {   src_ = src; last_ = 0;  get_value();    return *this;   }
    LineReader& operator=(const char* src)
    {   src_ = src; last_ = 0;  get_value();    return *this;   }

    // vfij̎Q
    const string& operator*() const
    {   return tok_;    }
    const string* operator->() const
    {   return &tok_;   }

    // ̗vfij
    LineReader& operator++()
    {   get_value();    return *this;   }
    LineReader operator++(int)
    {   LineReader tmp = *this; get_value();    return tmp; }

    // rZ
    friend bool operator==(const LineReader& x, const LineReader& y)
    {   return x.first_ == y.first_ && x.last_ == y.last_ && x.crlf_ == y.crlf_;    }
    friend bool operator!=(const LineReader& x, const LineReader& y)
    {   return !(x == y);   }
};


/////////////////////////////////////////////////////////////////////////////////
//
inline void
LineReader::get_value()
{
    if (last_ == string::npos) { first_ = string::npos; crlf_ = false; return; }
    first_ = find_first();
    if (first_ == string::npos) { tok_ = ""; last_ = string::npos; return; }
    last_ = src_.find_first_of("\r\n", first_);
    string::size_type n = (last_ == string::npos) ? last_ : last_-first_;
    tok_.assign(src_, first_, n);
}


inline string::size_type
LineReader::find_first()
{
    string::size_type top = last_;
    crlf_ = false;

    try {
        string::iterator begin = src_.begin();
        string::iterator end = src_.end();
        string::iterator org = begin;
        advance(begin, top);
        if (begin != end && *begin == '\r') { ++begin; crlf_ = true; }
        if (begin != end && *begin == '\n') { ++begin; crlf_ = true; }
        top = (begin != end) ? distance(org, begin) : string::npos;
    }
    catch (...) {
        top = string::npos;
    }
    return top;
}


/////////////////////////////////////////////////////////////////////////////////
//
